class  Convection {
	public static void main(String args[]){
/*************************************************************
     Program for convection with explicit method
*************************************************************/
        int NMAX=101;
        int NI;
	int i,ii,niter;
	double dx,xmax,d,alpha,c,u0;
	double time,dt,tmax;
	double f[]   = new double [NMAX];
	double x[]     = new double [NMAX];
	double f_n[]    = new double [NMAX];
        
	alpha=0.00001;
	u0=1.0;
	NI=100;
	xmax=0.1;
	tmax=0.01;
	dt=0.000001;

	dx=xmax/(double)NI; 	
	c=u0*dt/dx;
	d=alpha*dt/(dx*dx);	
	x[0]=0.0;
	for(i=1;i<NI;i++)
        {
		x[i]=x[i-1]+dx;
	}
	
	/*	INITIAL VALUES FOR VELOCITY		*/
       	for(i=0;i<NI;i++)
	{
		if(i>5 && i<=20)f[i]=1.0;
		else f[i]=0.0;
	}
      	niter=0;
	time=0.0;
	System.out.println("T=" + time);
	for(i=0;i<NI;i++)
	{
		System.out.println(u0*time+dx*(double)i+" "+f[i]);
	}
	
	/*	CALCILATE CONVECTION WITH MARCHING    */
	while(time<tmax)
	{
   		niter++;
		time += dt;
              	for(i=1;i<NI-1;i++)
		{
			f_n[i]=f[i]-0.5*c*(f[i+1]-f[i-1])
				+d*(f[i+1]-2.0*f[i]-f[i-1]);
		}
		f_n[0]=0.0;
		f_n[NI]=f_n[NI-1];
		
		for(i=0;i<NI;i++)
		{
          		f[i]=f_n[i];
		}
	}
		System.out.println("T=" + time);
		for(i=0;i<NI;i++)
		{
          		f[i]=f_n[i];
			System.out.println(u0*time+dx*(double)i+" "+f[i]);			}
			System.out.println();
		}
}
